Package com.sas.metadata.remote

# Interface PSPortlet

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface PSPortlet extends PrimaryType
A Web component that is managed by a Web application and that is aggregated with other portlets to form a page within the application. Portlets can process requests from the user and generate dynamic content.

Attributes of PSPortlet are:

- `portletType`

Associations of PSPortlet are:

- `LayoutComponents`
- `AssociatedContentCollection`

## Usage

To create an instance of this PSPortlet, use the `factory` create methods.
Example: create a PSPortlet with name "PSPortlet_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PSPortlet myObject = (PSPortlet) factory.createComplexMetadataObject(objectStore, "PSPortlet_Object", MetadataObjects.PSPORTLET, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDCONTENTCOLLECTION_NAME`
  Constant used for the name of the AssociatedContentCollection association.
  `static final String`
  `ASSOCIATION_LAYOUTCOMPONENTS_NAME`
  Constant used for the name of the LayoutComponents association.
  `static final String`
  `ATTRIBUTE_PORTLETTYPE_NAME`
  Constant used for the name of the portletType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Tree`
  `getAssociatedContentCollection()`
  Gets the `Tree` for `AssociatedContentCollection`
  `AssociationList`
  `getAssociatedContentCollections()`
  Gets the Association list of `AssociatedContentCollections`
  `AssociationList`
  `getAssociatedContentCollections(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedContentCollections`
  `AssociationList`
  `getLayoutComponents()`
  Gets the AssociationList of `LayoutComponents`
  `AssociationList`
  `getLayoutComponents(boolean fGoToServer)`
  Gets the Associationlist of `LayoutComponents`
  `String`
  `getportletType()`
  Gets the `String` value of `portletType`
  `int`
  `getportletTypeMaxLength()`
  Gets the maximum length of `portletType`
  `int`
  `getportletTypeState()`
  Gets the Metadata State of `portletType`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `LayoutComponents`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedContentCollection(Tree inObject)`
  Sets the `AssociatedContentCollections` list 0th element to be `inObject`.
  `void`
  `setAssociatedContentCollections(AssociationList list)`
  Sets the `AssociatedContentCollections` list to be `list`.
  `void`
  `setAssociatedContentCollections(AssociationList list, int state)`
  Sets the `AssociatedContentCollections` list to be `list`.
  `void`
  `setLayoutComponents(AssociationList list)`
  Sets the `LayoutComponents` list to be `list`.
  `void`
  `setLayoutComponents(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setportletType(String inportletType)`
  Sets the `portletType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setportletType(String inportletType, int state)`
  Sets the `portletType` Metadata State.
  `void`
  `setportletTypeState(int state)`
  Sets the Metadata State of `portletType`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_PORTLETTYPE_NAME

    static final String ATTRIBUTE_PORTLETTYPE_NAME
    Constant used for the name of the portletType attribute.

    portletType: A description of the functionality of the task the Portlet performs.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LAYOUTCOMPONENTS_NAME

    static final String ASSOCIATION_LAYOUTCOMPONENTS_NAME
    Constant used for the name of the LayoutComponents association.

    LayoutComponents: The LayoutComponent that specifies the layout of the Portlets on a PortalPage

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDCONTENTCOLLECTION_NAME

    static final String ASSOCIATION_ASSOCIATEDCONTENTCOLLECTION_NAME
    Constant used for the name of the AssociatedContentCollection association.

    AssociatedContentCollection: The tree that contains hierarchical information pertaining to this object. For example, Portal collections would be stored in a tree hierarchy and associated to the PSPortlet using this association.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `LayoutComponents`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getportletType

    String getportletType() throws RemoteException
    Gets the `String` value of `portletType`
    Returns:
      The `portletType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getportletTypeState

    int getportletTypeState() throws RemoteException
    Gets the Metadata State of `portletType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getportletTypeMaxLength

    int getportletTypeMaxLength() throws RemoteException
    Gets the maximum length of `portletType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLayoutComponents

    AssociationList getLayoutComponents() throws RemoteException, MdException
    Gets the AssociationList of `LayoutComponents`
    Returns:
      Returns the AssociationList of `LayoutComponents` which can be of type:
      PSLayoutComponent
      PSColumnLayoutComponent
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedContentCollections

    AssociationList getAssociatedContentCollections() throws RemoteException, MdException
    Gets the Association list of `AssociatedContentCollections`
    Returns:
      The AssociationList of `AssociatedContentCollections` which can be of type:
      Tree
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedContentCollection

    Tree getAssociatedContentCollection() throws RemoteException, MdException
    Gets the `Tree` for `AssociatedContentCollection`
    Returns:
      The `Tree` ( `null` if not set ) of `AssociatedContentCollection` which can be of type:
      Tree
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLayoutComponents

    AssociationList getLayoutComponents(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `LayoutComponents`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `LayoutComponents` which can be of type:
      PSLayoutComponent
      PSColumnLayoutComponent
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedContentCollections

    AssociationList getAssociatedContentCollections(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedContentCollections`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedContentCollections` which can be of type:
      Tree
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setportletType

    void setportletType(String inportletType) throws RemoteException
    Sets the `portletType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inportletType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setportletType

    void setportletType(String inportletType, int state) throws RemoteException
    Sets the `portletType` Metadata State.
    Parameters:
      `inportletType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setportletTypeState

    void setportletTypeState(int state) throws RemoteException
    Sets the Metadata State of `portletType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLayoutComponents

    void setLayoutComponents(AssociationList list) throws RemoteException
    Sets the `LayoutComponents` list to be `list`. Objects of which can be of type:
    PSLayoutComponent
    PSColumnLayoutComponent
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLayoutComponents

    void setLayoutComponents(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedContentCollections

    void setAssociatedContentCollections(AssociationList list) throws RemoteException
    Sets the `AssociatedContentCollections` list to be `list`. Objects of which can be of type:
    Tree
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedContentCollections

    void setAssociatedContentCollections(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedContentCollections` list to be `list`. Objects of which can be of type:
    Tree
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedContentCollection

    void setAssociatedContentCollection(Tree inObject) throws RemoteException
    Sets the `AssociatedContentCollections` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Tree
    Throws:
      `RemoteException` - If error communicating with remote object.